???File Path
==========
***...\ClientApp\srcpp\src\travel\master-grouping\master-grouping.component.ts


???Check the points
==================
1) Check ...\ClientApp\srcpp\srcaseranchranch.component.ts and ...\ClientApp\srcpp\srcase\company\company.component.ts 
2) Main Grouping Must
	-> // @@@@@@@ AREA=> FROM HTML INPUT AREA Called Functions(Not Button bar and List) @@@@@@@@@@@@@@
	-> // @@@@@@@ FROM HTML MAIN LIST Called Functions @@@@@@@@@@@@@@
	-> // @@@@@@@ AREA=> FROM HTML BUTTON BAR Called Functions @@@@@@@@@@@@@@
	-> // @@@@@@@ AREA=> COMMON Functions @@@@@@@@@@@@@@
3) Set GUI Heading in constructor(Eg:- insGlobalConstants.strGuiHeading = "***";)
4) Set GUI/Menu System Name in constructor(Eg:- insGlobalConstants.strSysModuleName = "***";) based on menu service
5) Set GUI Tittle(Browser Tab) in constructor(Eg:- insGlobalFunctions.fnSetGuiBasedBrowserTitle = "***";)



            // ??? Check and Use If you need...
            //---------------------------------
            import { Component, OnInit, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
            import { DxDataGridComponent } from "devextreme-angular";

            import * as globalConstantsService from '../../../services/global-constants.service';
            import * as globalFunctionsService from '../../../services/global-functions.service';
            import * as globalDataService from '../../../services/global-data.service';
            import * as baseDataService from '../../../services/base/base-data.service';
            import * as jspdfService from '../../../services/jspdf.service';
            import * as menuService from '../../../services/menu.service';
            import { MdlMasterGrouping, MdlReqMasterGrouping, MdlResMasterGrouping, MdlResMasterGroupingInit, MdlResMasterGroupingList } from '../../../models/travel/service.model';
            import { MdlResponse, MdlBaseIntId, MdlReqBaseIntId } from "../../../models/common.model";
            import { HttpService } from '../../../services/http.service';
        


            // ??? Check and Use If you need...
            //---------------------------------
            export class MasterGroupingComponent implements OnInit, AfterViewInit, OnDestroy {
                // ** initialize data
                public mdlMasterGrouping: MdlMasterGrouping = new MdlMasterGrouping();
                public intActiveMasterGroupingIndex: number = -1;
                // ** Select and Auto-completion
                // ??? Remove not use items !!!

                // ** GUI Control
                public blnBtnDisabled: boolean = false;
                public blnMoreDivExpanded: boolean = false;
                // ** MasterGrouping List
                @ViewChild('#idDgMasterGroupingList') idDgMasterGroupingList!: DxDataGridComponent;
                public lstAllMasterGrouping: MdlMasterGrouping[] = [];
                public blnDgMasterGroupingShowFilterRow: boolean = false;
                public blnDgMasterGroupingHeaderFilter: boolean = false;
                public intActiveMasterGroupingListItemIndex = -1;
        


                // ??? If you need, import and create instance other common classes !!!
                constructor(public insGlobalConstants: globalConstantsService.GlobalConstantsService,
                        public insGlobalFunctions: globalFunctionsService.GlobalFunctionsService,
                        public insGlobalData: globalDataService.GlobalDataService,
                        public insBaseData: baseDataService.BaseDataService,
                        private insHttpService: HttpService,
                        public insJspdf: jspdfService.JspdfService) {
    
                    insGlobalConstants.strGuiHeading = 'masterGrouping';
                    // ??? Check menu service !!!
                    insGlobalConstants.strSysModuleName = "MASTERGROUPING_MASTER";
                    insGlobalFunctions.fnSetGuiBasedBrowserTitle("MasterGrouping");
                }

                ngOnInit(): void {
                    this.blnBtnDisabled = true;
                    document.body.style.cursor = "wait";

                    this.fnDefaultView();

                    // initialize Data Request
                    this.insHttpService.get('Base/Organization/GetMasterGroupingInitializeData')
                    .then((mdlResMasterGroupingInit: MdlResMasterGroupingInit) => {
                        if (mdlResMasterGroupingInit.sinStatus == 1) {
                            this.lstMdlMasterGrouping = mdlResMasterGroupingInit.lstMdlMasterGrouping;

                            // ??? Remove not use items !!!

                        } else {
                            console.log(mdlResMasterGroupingInit.strMessage + " => " + mdlResMasterGroupingInit.strErrorCode + ' -> ' + mdlResMasterGroupingInit.strSysError);
                        }
                    })
                    .catch((err: any) => {
                        console.log("Error->MASTERGROUPING.COMPONENT.TS#001: " + JSON.stringify(err));
                    });

                    document.body.style.cursor = "default";
                    this.blnBtnDisabled = false;
                }

                ngAfterViewInit(): void {
                }

                ngOnDestroy() {
                }
        


            // @@@@@@@ AREA=> FROM HTML INPUT AREA Called Functions(Not Button bar and List) @@@@@@@@@@@@@


            // ??? AUTO/ENTRY COMPLETE - Set Id[, Code, Name] -> OnFocusOut Event

            // ??? Any caculation/Display Based on user inputs

        


            // @@@@@@@@@@@@@@@@@@@@@@@ AREA=> FROM HTML MAIN LIST Called Functions @@@@@@@@@@@@@@@@@@@@@@@@

            fnOnMasterGroupingListEditButtonClick(objSelRow: any) {
                this.blnBtnDisabled = true;
                document.body.style.cursor = "wait";

                this.fnSetDataAndGuiEditMode(objSelRow.row.data, objSelRow.row.rowIndex);

                document.body.style.cursor = "default";
                this.blnBtnDisabled = false;
            }

            fnOnMasterGroupingListRowDblClick(objDblClickRowData: any) {
                this.blnBtnDisabled = true;
                document.body.style.cursor = "wait";

                this.fnSetDataAndGuiEditMode(objDblClickRowData.data, objDblClickRowData.rowIndex);

                document.body.style.cursor = "default";
                this.blnBtnDisabled = false;
            }

            fnOnDgFilterRowEnableDisableClick() {
                this.blnDgShowFilterRow = !this.blnDgShowFilterRow;
            }

            fnOnDgHeadeFilterEnableDisableClick() {
                this.blnDgHeaderFilter = !this.blnDgHeaderFilter;
            }
        


            // @@@@@@@@@@@@@@@@@@@@@@ AREA=> FROM HTML BUTTON BAR Called Functions @@@@@@@@@@@@@@@@@@@@@@@@

            async fnOnSaveButtonClick() {
            this.blnBtnDisabled = true;
            document.body.style.cursor = "wait";
            this.fnDefaultView(false, true, true, false);

            // Add or Update 
            try {
            // Input Validation
            this.fnInputValidation(this.mdlMasterGrouping);

            // Input Data set
            //....

            // Set Save Request Inputs
            let mdlReqMasterGrouping: MdlReqMasterGrouping = new MdlReqMasterGrouping();
            mdlReqMasterGrouping.mdlMasterGrouping = JSON.parse(JSON.stringify(this.mdlMasterGrouping));

            // Request Data Reset
            //....

            // Save Request
            await this.insHttpService.post('Base/Organization/SaveMasterGrouping', mdlReqMasterGrouping)
                .then((mdlResMasterGrouping: MdlResMasterGrouping) => {
                if (mdlResMasterGrouping.sinStatus == 1) {
                    this.mdlMasterGrouping = mdlResMasterGrouping.mdlMasterGrouping;
                    if (this.intActiveMasterGroupingIndex == -1) {
                    // New Item
                    this.intActiveMasterGroupingIndex = this.lstMdlMasterGrouping.length;
                    this.lstMdlMasterGrouping.push(JSON.parse(JSON.stringify(this.mdlMasterGrouping)));
                    }
                    else {
                    // Update
                    this.lstMdlMasterGrouping[this.intActiveMasterGroupingIndex] = JSON.parse(JSON.stringify(this.mdlMasterGrouping));
                    //this.lstMdlMasterGrouping.splice(this.intActiveMasterGroupingIndex, 1, this.mdlMasterGrouping);
                    }

                    this.insGlobalConstants.fnSetSuccessMessage(mdlResMasterGrouping.strMessage);
                } else {
                    this.insGlobalConstants.fnSetErrorMessage(mdlResMasterGrouping.strMessage, mdlResMasterGrouping.strSysError);
                    console.log(mdlResMasterGrouping);
                }
                })
                .catch((err: any) => {
                    this.insGlobalConstants.fnSetErrorMessage(JSON.stringify(err));
                });

            } catch (ex: unknown) {
                if (ex instanceof Error) {
                    //this.insGlobalConstants.strErrorMessages = ex.message;
                    this.insGlobalConstants.fnSetErrorMessage(ex.message);
                }
                console.log("Error->MASTERGROUPING.COMPONENT.TS#002: " + ex);
            }

            this.fnDefaultView(false, false, true, false);
            document.body.style.cursor = "default";
            this.blnBtnDisabled = false;
        }

        fnOnNewButtonClick() {
            this.blnBtnDisabled = true;
            document.body.style.cursor = "wait";

            this.fnDefaultView(true, true, true, false);

            document.body.style.cursor = "default";
            this.blnBtnDisabled = false;
        }

        async fnOnDeleteButtonClick() {
            this.blnBtnDisabled = true;
            document.body.style.cursor = "wait";
            this.fnDefaultView(false, true, false, false);

            // Delete 
            try {

            // Input Validation
            if (this.mdlMasterGrouping.binMasterGroupingId == null || this.mdlMasterGrouping.binMasterGroupingId < 1) {
                throw new Error('Select MasterGrouping for DELETE.');
            }

            // Set Delete Request Inputs
            let mdlReqMasterGroupingBaseIntId: MdlReqBaseIntId = new MdlReqBaseIntId();
            mdlReqMasterGroupingBaseIntId.mdlBaseIntId.binPkId = this.mdlMasterGrouping.binMasterGroupingId;
            mdlReqMasterGroupingBaseIntId.mdlBaseIntId.binCustomValue = this.mdlMasterGrouping.intSysActionId;
            
            // Delete Request
            await this.insHttpService.post('Base/Organization/DeleteMasterGrouping', mdlReqMasterGroupingBaseIntId)
                .then((mdlResponse: MdlResponse) => {
                if (mdlResponse.sinStatus == 1) {
                    this.lstMdlMasterGrouping.splice(this.intActiveMasterGroupingIndex, 1);
                    this.fnDefaultView(true, false, false, false);
                    this.insGlobalConstants.fnSetSuccessMessage(mdlResponse.strMessage);
                } else {
                    this.insGlobalConstants.fnSetErrorMessage(mdlResponse.strMessage, mdlResponse.strSysError);
                    console.log(mdlResponse);
                }
                })
                .catch((err: any) => {
                this.insGlobalConstants.fnSetErrorMessage(JSON.stringify(err));
                });

            } catch (ex: unknown) {
            if (ex instanceof Error) {
                this.insGlobalConstants.fnSetErrorMessage(ex.message);
            }
            console.log("Error->MASTERGROUPING.COMPONENT.TS#003: " + ex);
            }

            document.body.style.cursor = "default";
            this.blnBtnDisabled = false;
        }

        


            // @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ AREA=> COMMON Functions @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


            fnDefaultView(blnClearData: boolean = true, blnClearMessages: boolean = true, blnMoreDivExpanded: boolean = false, blnGotoBottom: boolean = false) {
                if (blnClearData) {
                    this.mdlMasterGrouping = new MdlMasterGrouping();
                    this.intActiveMasterGroupingIndex = -1;
                }

                this.blnMoreDivExpanded = blnMoreDivExpanded;

                if (blnClearMessages) {
                    this.insGlobalConstants.strErrorMessages = "";
                    this.insGlobalConstants.strSuccessMessages = "";
                }
                
                if (!blnGotoBottom)
                    this.insGlobalFunctions.fnWindowScrollTop();
                else {
                    this.insGlobalFunctions.fnWindowScrollbottom();
                }
            }

            fnSetDataAndGuiEditMode(mdlMasterGrouping: MdlMasterGrouping, intRowIndex: number) {
                this.mdlMasterGrouping = JSON.parse(JSON.stringify(mdlMasterGrouping));
                this.intActiveMasterGroupingIndex = intRowIndex;
                this.fnDefaultView(false, true, true, false);
            }

            fnInputValidation(mdlMasterGrouping: MdlMasterGrouping) {
                // ??? CHECK
                
                if (mdlMasterGrouping.strGroupingName == "") {
                    throw new Error('Enter/Select Grouping Name.');
                }
            

                // ??? CHECK CODE and NAME [Other UNIQUE Fields] Already exists
            }
        

